package com.cmeeting.constant;

/**
 * 用户系统功能接口
 *
 * @author hong
 */
public interface UserAdminRouteConstant {
    String ACCESS_TOKEN = "/chatbot/getAccessToken";
    /**
     * 自建用户
     */
    interface SysUser {
        /**
         * 分类查询接口
         */
        String CATEGORY_TREE = "/chatbot/user/category/tree";

        /**
         * 创建系统自建用户分类
         */
        String ADD_CATEGORY = "/chatbot/user/category/add";

        /**
         * 编辑用户分类
         */
        String EDIT_CATEGORY = "/chatbot/user/category/edit";
        /**
         * 删除用户分类
         */
        String DELETE_CATEGORY = "/chatbot/user/category/remove";
        /**
         * 查询用户列表
         */
        String UPDATE_PASS = "/chatbot/user/updatePass";
        String LIST = "/chatbot/user/list";
        /**
         * 创建用户
         */
        String ADD = "/chatbot/user/add";
        String COUNT = "/chatbot/user/count";
        /**
         * 更新用户
         */
        String EDIT = "/chatbot/user/edit";
        /**
         * 删除用户
         */
        String DELETE = "/chatbot/user/delete";
        /**
         * 批量删除用户
         */
        String BATCH_DELETE = "/chatbot/user/deleteBatchIds";
        /**
         * 用户详情
         */
        String INFO = "/chatbot/user/info";
        /**
         * 根据条件查询所有三类用户
         */
        String FIND = "/chatbot/user/find";
        String FIND_TENANT_ID = "/chatbot/user/findTenantIdByUserId";
        String FIND_BY_UID = "/chatbot/user/findByUid";
        String FIND_USER_BY_UID = "/chatbot/user/findUserByUid";
        String FIND_NAME = "/chatbot/user/findName";          //根据用户和分类ID查询对应name
        String FIND_ADMIN_NAME = "/chatbot/user/findAdminName";          //超管查询根据用户和分类ID查询对应name、checked
        String FIND_SHARE_NAME = "/chatbot/user/findShareName";          //超管查询根据用户和分类ID查询对应name、checked
        String INIT = "/chatbot/user/init";          // 创建租户的时候 初始化用户系统 Get请求 参数：tenantId, applicationId

        String PUSH = "/chatbot/user/push";
        String EXPORT = "/chatbot/user/export";
    }

    /**
     * 同步用户
     */
    interface SyncUser {
        String CATEGORY_TREE = "/chatbot/user/sync/category/tree";  // 查询分类
        String LIST = "/chatbot/user/sync/list";               //查询用户
        String FIELD_INFO = "/chatbot/user/sync/field/info";        //查询属性
        String FIELD_UPDATE = "/chatbot/user/sync/field/update";          //更新属性值
//        String ADD = "/chatbot/user/sync/add";          //新增
        String TREE = "/chatbot/user/sync/tree";          //用户查询
        String INFO = "/chatbot/user/sync/info";          //用户详情
        String PUSH = "/chatbot/user/sync/push";          //用户同步
        String ZHONGJI_PUSH = "/chatbot/user/sync/zhongji_push";          //用户同步-中集同步接口
        String INIT_TEMP_TABLE = "/chatbot/user/sync/initTempTable";          //初始化临时表
        String HANDEL_PTAH = "/chatbot/user/sync/category/handelPath";          //用户同步后处理分类
        String COMMIT_OR_ROLLBACK = "/chatbot/user/sync/commitOrRollback";          //用户同步后处理分类
        String REMOVE = "/chatbot/user/sync/field/remove";          //属性删除
        String MOVE = "/chatbot/user/sync/field/move";          //用户同步
        String INIT = "/chatbot/user/sync/init";          //用户同步
        String DEPART = "/chatbot/user/sync/getAllDeptByUserId";      //用户部门

        String TRUNCATE = "/chatbot/user/sync/truncate";      //用户部门

        String ALL_CHILDREN = "/chatbot/user/sync/children"; //查询部门下所有子部门id以及用户id
        String BATCH_DELETE = "/chatbot/user/sync/batchDelete";      //用户部门
        String FIND_DEPT_NAME = "/chatbot/user/sync/getAllDeptByUserId";//查询部门全路径//用户同步

        String ADMIN_LIST = "/chatbot/user/sync/adminList"; //超管同步用户授权给租户查询
        String AUTH_LIST = "/chatbot/user/sync/authList"; //超管同步用户已授权用户/部门查询
        String AUTH = "/chatbot/user/sync/auth"; //超管同步用户已授权用户/部门查询
        String REMOVE_AUTH = "/chatbot/user/sync/removeAuth"; //超管同步用户已授权用户/部门查询
        String SHARE_TREE = "/chatbot/shareUser/tree"; //超管分享的部门查询
        String SHARE_LIST = "/chatbot/shareUser/list"; //超管分享的用户查询

    }

    /**
     * 应用用户
     */
    interface ApplicationUser {
        String ADD_CATEGORY = "/chatbot/user/application/category/add"; // 新增分类
        String EDIT_CATEGORY = "/chatbot/user/application/category/edit"; // 编辑分类
        String CATEGORY_TREE = "/chatbot/user/application/category/tree"; // 查询分类
        String DELETE_CATEGORY = "/chatbot/user/application/category/remove"; // 删除分类
        String ADD = "/chatbot/user/application/add"; // 新增用户
        String EDIT = "/chatbot/user/application/edit"; // 编辑用户信息
        String BATCH_EDIT = "/chatbot/user/application/batchEdit"; // 编辑用户信息
        String BATCH_DELETE = "/chatbot/user/application/batchDelete"; // 编辑用户信息

        String DELETE = "/chatbot/user/application/delete"; // 删除用户
        String LIST = "/chatbot/user/application/list"; // 用户列表
        String INFO = "/chatbot/user/application/info"; // 用户详情
    }
    interface  Report{
        String COUNT = "/chatbot/report/user/count"; // 应用用户+系统用户  总计和新增
    }


}
